(function (global, factory) {
  if (typeof define === 'function' && define.amd) {
    define(['exports', 'module', 'react'], factory);
  } else if (typeof exports !== 'undefined' && typeof module !== 'undefined') {
    factory(exports, module, require('react'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, mod, global.React);
    global.ReactHighlighted = mod.exports;
  }
})(this, function (exports, module, _react) {
  'use strict';

  var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

  var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

  var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

  function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

  function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

  var _React = _interopRequireDefault(_react);

  function matchIndex(text, query, caseSensitive) {
    if (caseSensitive) {
      return text.indexOf(query);
    }
    return text.toLowerCase().indexOf(query.toLowerCase());
  }

  function higlightText(text, query, caseSensitive, textTag, textProps, higlightTag, higlightProps) {
    if (!query || !query.length || matchIndex(text, query, caseSensitive) === -1) {
      return _React['default'].createElement(textTag, textProps, text);
    }
    var result = [];
    var rest = text;
    var index = matchIndex(rest, query, caseSensitive);
    while (index !== -1) {
      if (index !== 0) {
        result.push(_React['default'].createElement(textTag, _extends({}, textProps, { key: result.length }), rest.substr(0, index)));
      }
      result.push(_React['default'].createElement(higlightTag, _extends({}, higlightProps, { key: result.length }), rest.substr(index, query.length)));
      rest = rest.substr(index + query.length);
      index = matchIndex(rest, query, caseSensitive);
    }
    if (rest.length) {
      result.push(_React['default'].createElement(textTag, _extends({}, textProps, { key: result.length }), rest));
    }
    return result;
  }

  var ReactHighlighted = (function (_React$Component) {
    _inherits(ReactHighlighted, _React$Component);

    function ReactHighlighted() {
      _classCallCheck(this, ReactHighlighted);

      _get(Object.getPrototypeOf(ReactHighlighted.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(ReactHighlighted, [{
      key: 'render',
      value: function render() {
        var _props = this.props;
        var caseSensitive = _props.caseSensitive;
        var tag = _props.tag;
        var textTag = _props.textTag;
        var textProps = _props.textProps;
        var higlightTag = _props.higlightTag;
        var higlightProps = _props.higlightProps;
        var text = _props.text;
        var query = _props.query;

        var props = _objectWithoutProperties(_props, ['caseSensitive', 'tag', 'textTag', 'textProps', 'higlightTag', 'higlightProps', 'text', 'query']);

        return _React['default'].createElement(tag, props, higlightText(text, query, caseSensitive, textTag, textProps, higlightTag, higlightProps));
      }
    }], [{
      key: 'propTypes',
      value: {
        caseSensitive: _react.PropTypes.bool,
        tag: _react.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.string]),
        textTag: _react.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.string]),
        textProps: _react.PropTypes.object,
        higlightTag: _react.PropTypes.oneOfType([_react.PropTypes.element, _react.PropTypes.string]),
        higlightProps: _react.PropTypes.object,
        text: _react.PropTypes.string.isRequired,
        query: _react.PropTypes.string.isRequired
      },
      enumerable: true
    }, {
      key: 'defaultProps',
      value: {
        caseSensitive: false,
        tag: 'span',
        textTag: 'span',
        textProps: {},
        higlightTag: 'em',
        higlightProps: {}
      },
      enumerable: true
    }]);

    return ReactHighlighted;
  })(_React['default'].Component);

  module.exports = ReactHighlighted;
});
